# matplotlib demo
# viewing images



#########################################################################################
###### cb ######
#########################################################################################
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
#
# import numpy as np
# plt.clf() #clears current figure
# #img = mpimg.imread('Image_Process/cowbell.jpg') # read in image
# img = mpimg.imread('cowbell.jpg') # read in image
# fig = plt.figure(1)
#
# imgplot = plt.imshow(img)
# plt.title('I NEED MORE COWBELL!!!')
#
# plt.show(block=False) #displays figure, if block = True, enter gui backend
# # manually close figure to stop the blocking
#
# plt.pause(1) #needed or else figure does not show
# input("<Hit Enter To Close>")
# plt.close(fig)
#
#
#########################################################################################




#########################################################################################
###### PPAP ######
#########################################################################################
#
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
#
# import numpy as np
# plt.clf() #clears current figure
# img = mpimg.imread('Image_Process/pikotaro.jpg') # read in image
# fig = plt.figure(1)
# imgplot = plt.imshow(img)
# #plt.title('Pen Pineapple Apple Pen')
#
# plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
# plt.pause(1) #needed or else figure does not show
# input("<Hit Enter To Close>")
# plt.close(fig)
#
#
#########################################################################################




#########################################################################################
####### RGB channel decomposition #######
#########################################################################################
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
#
# import numpy as np
# plt.clf() #clears current figure
# img = mpimg.imread('Image_Process/marbles.jpg') # read in image
#
# img_R = img[:,:,0] # Red channel
# img_G = img[:,:,1] # Green channel
# img_B = img[:,:,2] # Blue channel
# fig = plt.figure(1)
#
# a = fig.add_subplot(2,3,4) # similar to matlab subplot but arrangement is diff
# imgplot = plt.imshow(img_R, cmap = 'gray')
# a.set_title('Red Channel')
#
# a = fig.add_subplot(2,3,5)
# imgplot = plt.imshow(img_G, cmap = 'gray')
# a.set_title('Green channel')
#
# a = fig.add_subplot(2,3,6)
# imgplot = plt.imshow(img_B, cmap = 'gray')
# a.set_title('Blue channel')
#
# a = fig.add_subplot(2,3,2)
# imgplot = plt.imshow(img)
# a.set_title('Color Image')
#
# plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
# plt.pause(1) #needed or else figure does not show
# input("<Hit Enter To Close>")
# plt.close(fig)
#
#
#########################################################################################



### downsample image ###
import matplotlib.pyplot as plt # matplotlib = python plotting library
import matplotlib.image as mpimg # image viewing

import numpy as np
plt.clf() #clears current figure
img = mpimg.imread('Image_Process/cowbell.jpg') # read in image
fig = plt.figure(1)

img2 = img[::2,::2,:]
img3 = img2[::4,::4,:]

a = fig.add_subplot(1,3,1) # similar to matlab subplot but arrangement is diff
imgplot = plt.imshow(img, interpolation = 'nearest')
a.set_title('OG image')

a = fig.add_subplot(1,3,2) # similar to matlab subplot but arrangement is diff
imgplot = plt.imshow(img2, interpolation = 'nearest')
a.set_title('downsample 2x in each dim')

a = fig.add_subplot(1,3,3) # similar to matlab subplot but arrangement is diff
imgplot = plt.imshow(img3, interpolation = 'nearest')
a.set_title('downsample 8x in each dim')


plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
plt.pause(1) #needed or else figure does not show
input("<Hit Enter To Close>")
plt.close(fig)
#####




#########################################################################################
###### checkerboard ######
#########################################################################################
# import matplotlib.pyplot as plt # matplotlib = python plotting library
# import matplotlib.image as mpimg # image viewing
# import numpy as np
# import time
# check = np.zeros((9, 9))
# check[::2, 1::2] = 128
# check[1::2, ::2] = 128
# import matplotlib.pyplot as plt
#
# #version 1: hit enter to close fig
# fig = plt.figure() #create figure
# plt.imshow(check, cmap='gray', interpolation='nearest') #draw image on current figure
# plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
# plt.pause(1) #needed or else figure does not show
# input("<Hit Enter To Close>")
# plt.close(fig)


# #version 2: pause for 1 sec and then close
# fig = plt.figure() #create figure
# plt.imshow(check, cmap='gray', interpolation='nearest') #draw image on current figure
# plt.draw()
# plt.show(block=False) #displays figure, if block = True, enter gui backend, figure close to stop the blocking
# plt.pause(1) #needed
# plt.close(fig)
#
#
##########################################################################################





#########################################################################################
####### surface plot animation ########
##########################################################################################
# import numpy as np
# import matplotlib.pyplot as plt
# import matplotlib.animation as animation
#
# fig = plt.figure()
#
# def f(x, y):
#     return np.sin(x) + np.cos(y)
#
# x = np.linspace(0, 2 * np.pi, 120)
# y = np.linspace(0, 2 * np.pi, 100).reshape(-1, 1)
# # ims is a list of lists, each row is a list of artists to draw in the
# # current frame; here we are just animating one artist, the image, in
# # each frame
# ims = []
# for i in range(60):
#     x += np.pi / 15.
#     y += np.pi / 20.
#     im = plt.imshow(f(x, y), animated=True)
#     ims.append([im])
#
# ani = animation.ArtistAnimation(fig, ims, interval=50, blit=True,
#                                 repeat_delay=1000)
# # ani.save('dynamic_images.mp4')
#
# plt.show()
#
#
#########################################################################################


